<?php
/* Autor...: William L. Taype Perez */
/* Esquema.: MST_ListaPrecioCabecera.xml */
/* Generado: 2021-06-25 23:59:51 */

/* Busqueda de registros de la tabla MST_ListaPrecioCabecera. */
abstract class BaseMST_ListaPrecioCabeceraFN extends MST_ListaPrecioCabeceraBN
{
    /* Declaracion de constantes */
    const IdListaPreciCab = "MST_ListaPrecioCabecera.IdListaPreciCab";
    const IdCompania = "MST_ListaPrecioCabecera.IdCompania";
    const IdSucursal = "MST_ListaPrecioCabecera.IdSucursal";
    const IdMoneda = "MST_ListaPrecioCabecera.IdMoneda";
    const IdTipoLista = "MST_ListaPrecioCabecera.IdTipoLista";
    const Estado = "MST_ListaPrecioCabecera.Estado";
    const FechaCreacion = "MST_ListaPrecioCabecera.FechaCreacion";
    const UsuarioCreacion = "MST_ListaPrecioCabecera.UsuarioCreacion";
    const FechaModificacion = "MST_ListaPrecioCabecera.FechaModificacion";
    const UsuarioModificacion = "MST_ListaPrecioCabecera.UsuarioModificacion";

    public $a_Condition = array();
    public $a_OrderBy = array();
    public $a_GroupBy = array();
    public $b_Debug = false;

    /* Obtiene una conexion a la base de datos */
    public function getConnect()
    {
        $o_DBConnect = Conexion::getConexion();
        return $o_DBConnect;
    }

    public function getDebug()
    {
        if( SF_DEBUG )
        {
            $this->b_Debug = true;
        }
        return $this->b_Debug;
    }

    public function setDebug( $v )
    {
        $this->b_Debug = $v;
    }

    /* Obtiene la cadena de columas */
    public function getSelectColumns()
    {
        $s_SQLQuery = "MST_ListaPrecioCabecera.IdListaPreciCab AS IdListaPreciCab, ";
        $s_SQLQuery .= "MST_ListaPrecioCabecera.IdCompania AS IdCompania, ";
        $s_SQLQuery .= "MST_ListaPrecioCabecera.IdSucursal AS IdSucursal, ";
        $s_SQLQuery .= "MST_ListaPrecioCabecera.IdMoneda AS IdMoneda, ";
        $s_SQLQuery .= "MST_ListaPrecioCabecera.IdTipoLista AS IdTipoLista, ";
        $s_SQLQuery .= "MST_ListaPrecioCabecera.Estado AS Estado, ";
        $s_SQLQuery .= "MST_ListaPrecioCabecera.FechaCreacion AS FechaCreacion, ";
        $s_SQLQuery .= "MST_ListaPrecioCabecera.UsuarioCreacion AS UsuarioCreacion, ";
        $s_SQLQuery .= "MST_ListaPrecioCabecera.FechaModificacion AS FechaModificacion, ";
        $s_SQLQuery .= "MST_ListaPrecioCabecera.UsuarioModificacion AS UsuarioModificacion ";
        return $s_SQLQuery;
    }

    /* Establece el condicion de filtro de la lista resultante */
    public function addCondition( $s_Const, $s_Operator, $u_Value, $b_ComSimple = true )
    {
        $this->a_Condition[] = array( "COLUMN" => $s_Const, "OPERATOR" => $s_Operator, "VALUE" => $u_Value, "FLAG_COMILLAS" => $b_ComSimple );
    }

    /* Establece el orden de la lista resultante */
    public function addOrderBy( $s_Const, $b_OrderAsc = true )
    {
        $this->a_OrderBy[] = array( "COLUMN" => $s_Const, "ASC" => $b_OrderAsc );
    }

    /* Establece el orden de la lista resultante */
    public function addGroupBy( $s_Const )
    {
        $this->a_GroupBy[] = array( "COLUMN" => $s_Const );
    }

    /* Establece los valores desde un objeto MST_ListaPrecioCabeceraBN */
    public function setByBN( MST_ListaPrecioCabeceraBN $o_MST_ListaPrecioCabeceraBN )
    {
        if ( !is_null( $o_MST_ListaPrecioCabeceraBN->getIdListaPreciCab() ) )
        {
            $this->setIdListaPreciCab( $o_MST_ListaPrecioCabeceraBN->getIdListaPreciCab() );
        }
        if ( !is_null( $o_MST_ListaPrecioCabeceraBN->getIdCompania() ) )
        {
            $this->setIdCompania( $o_MST_ListaPrecioCabeceraBN->getIdCompania() );
        }
        if ( !is_null( $o_MST_ListaPrecioCabeceraBN->getIdSucursal() ) )
        {
            $this->setIdSucursal( $o_MST_ListaPrecioCabeceraBN->getIdSucursal() );
        }
        if ( !is_null( $o_MST_ListaPrecioCabeceraBN->getIdMoneda() ) )
        {
            $this->setIdMoneda( $o_MST_ListaPrecioCabeceraBN->getIdMoneda() );
        }
        if ( !is_null( $o_MST_ListaPrecioCabeceraBN->getIdTipoLista() ) )
        {
            $this->setIdTipoLista( $o_MST_ListaPrecioCabeceraBN->getIdTipoLista() );
        }
        if ( !is_null( $o_MST_ListaPrecioCabeceraBN->getEstado() ) )
        {
            $this->setEstado( $o_MST_ListaPrecioCabeceraBN->getEstado() );
        }
        if ( !is_null( $o_MST_ListaPrecioCabeceraBN->getFechaCreacion() ) )
        {
            $this->setFechaCreacion( $o_MST_ListaPrecioCabeceraBN->getFechaCreacion() );
        }
        if ( !is_null( $o_MST_ListaPrecioCabeceraBN->getUsuarioCreacion() ) )
        {
            $this->setUsuarioCreacion( $o_MST_ListaPrecioCabeceraBN->getUsuarioCreacion() );
        }
        if ( !is_null( $o_MST_ListaPrecioCabeceraBN->getFechaModificacion() ) )
        {
            $this->setFechaModificacion( $o_MST_ListaPrecioCabeceraBN->getFechaModificacion() );
        }
        if ( !is_null( $o_MST_ListaPrecioCabeceraBN->getUsuarioModificacion() ) )
        {
            $this->setUsuarioModificacion( $o_MST_ListaPrecioCabeceraBN->getUsuarioModificacion() );
        }
    }

    /**
    * @return MST_ListaPrecioCabeceraBN|null
    * @throws SQLException
    */
    public function selectByPK( $i_IdListaPreciCab )
    {
        if( is_null( $i_IdListaPreciCab ) ){ $i_IdListaPreciCab = -1; } 
 
        $s_SQLQuery = "SELECT ";
        $s_SQLQuery .= $this->getSelectColumns();
        $s_SQLQuery .= "FROM MST_ListaPrecioCabecera ";
        $s_SQLQuery .= "WHERE IdListaPreciCab = ".$i_IdListaPreciCab." ";
        $s_SQLQuery .= "LIMIT 1;";
        if( $this->getDebug() ){ pr( $s_SQLQuery ); }
        $o_MST_ListaPrecioCabeceraBN = null;
        $o_Resource = $this->getConnect();
        $o_Statement = $o_Resource->prepareStatement( $s_SQLQuery );
        $o_ResultSet = $o_Statement->executeQuery();
        $i_NumRows   = $o_ResultSet->getRecordCount();
        if( $i_NumRows > 0 )
        {
            $o_ResultSet->next();
            $a_SQLRow = $o_ResultSet->getRow(); //devuele array
            $o_MST_ListaPrecioCabeceraBN = $this->insertObjectBN( $a_SQLRow );
        }
        return $o_MST_ListaPrecioCabeceraBN;
    }

    public function buildConsult()
    {
        $s_SQLQuery = "";
        if ( !is_null( $this->getIdListaPreciCab() ) ) $s_SQLQuery .= "MST_ListaPrecioCabecera.IdListaPreciCab = ".$this->getIdListaPreciCab()." AND ";
        if ( !is_null( $this->getIdCompania() ) ) $s_SQLQuery .= "MST_ListaPrecioCabecera.IdCompania = ".$this->getIdCompania()." AND ";
        if ( !is_null( $this->getIdSucursal() ) ) $s_SQLQuery .= "MST_ListaPrecioCabecera.IdSucursal = ".$this->getIdSucursal()." AND ";
        if ( !is_null( $this->getIdMoneda() ) ) $s_SQLQuery .= "MST_ListaPrecioCabecera.IdMoneda = '".$this->getIdMoneda()."' AND ";
        if ( !is_null( $this->getIdTipoLista() ) ) $s_SQLQuery .= "MST_ListaPrecioCabecera.IdTipoLista = ".$this->getIdTipoLista()." AND ";
        if ( !is_null( $this->getEstado() ) ) $s_SQLQuery .= "MST_ListaPrecioCabecera.Estado = '".$this->getEstado()."' AND ";
        if ( !is_null( $this->getFechaCreacion() ) ) $s_SQLQuery .= "MST_ListaPrecioCabecera.FechaCreacion = '".$this->getFechaCreacion()."' AND ";
        if ( !is_null( $this->getUsuarioCreacion() ) ) $s_SQLQuery .= "MST_ListaPrecioCabecera.UsuarioCreacion = '".$this->getUsuarioCreacion()."' AND ";
        if ( !is_null( $this->getFechaModificacion() ) ) $s_SQLQuery .= "MST_ListaPrecioCabecera.FechaModificacion = '".$this->getFechaModificacion()."' AND ";
        if ( !is_null( $this->getUsuarioModificacion() ) ) $s_SQLQuery .= "MST_ListaPrecioCabecera.UsuarioModificacion = '".$this->getUsuarioModificacion()."' AND ";
        if ( count( $this->a_Condition ) > 0 )
        {
            foreach ( $this->a_Condition as $a_Condition )
            {
                if( $a_Condition['FLAG_COMILLAS'] )
                {
                    $s_SQLQuery .= $a_Condition[ "COLUMN" ]." ".$a_Condition[ "OPERATOR" ]." '".$a_Condition[ "VALUE" ]."' AND ";
                }
                else
                {
                    $s_SQLQuery .= $a_Condition[ "COLUMN" ]." ".$a_Condition[ "OPERATOR" ]." ".$a_Condition[ "VALUE" ]." AND ";
                }
            }
        }
        $s_SQLQuery .= "1 = 1 ";
        return $s_SQLQuery;
    }

    public function selectNumRows()
    {
        $s_SQLQuery = "SELECT ";
        $s_SQLQuery .= "COUNT(*) AS cnt ";
        $s_SQLQuery .= "FROM MST_ListaPrecioCabecera WHERE ";
        $s_SQLQuery .= $this->buildConsult();
        
        if ( count( $this->a_GroupBy ) > 0 )
        {
            $s_SQLQuery .= "GROUP BY ";
            $s_Separator = "";
            foreach ( $this->a_GroupBy as $a_GroupBy )
            {
                $s_SQLQuery .= $s_Separator.$a_GroupBy[ "COLUMN" ]." ";
                $s_Separator = ", ";
            }
        }
        if( $this->getDebug() ){ pr( $s_SQLQuery ); }
        $o_Resource = $this->getConnect();
        $o_Statement = $o_Resource->prepareStatement( $s_SQLQuery );
        $o_ResultSet = $o_Statement->executeQuery();
        $o_ResultSet->next();
        $i_NumRows    = $o_ResultSet->getInt( 'cnt' );
        return $i_NumRows;
    }

    /**
    * @param null $i_Position
    * @param null $i_Rows
    * @return MST_ListaPrecioCabeceraBN[]
    * @throws SQLException
    */
    public function select( $i_Position = null, $i_Rows = null )
    {
        $s_SQLQuery = "SELECT ";
        $s_SQLQuery .= $this->getSelectColumns();
        $s_SQLQuery .= "FROM MST_ListaPrecioCabecera WHERE ";
        $s_SQLQuery .= $this->buildConsult();
        if ( count( $this->a_GroupBy ) > 0 )
        {
            $s_SQLQuery .= "GROUP BY ";
            $s_Separator = "";
            foreach ( $this->a_GroupBy as $a_GroupBy )
            {
                $s_SQLQuery .= $s_Separator.$a_GroupBy[ "COLUMN" ]." ";
                $s_Separator = ", ";
            }
        }
        if ( count( $this->a_OrderBy ) > 0 )
        {
            $s_SQLQuery = $s_SQLQuery."ORDER BY ";
            $s_Separator = "";
            foreach ( $this->a_OrderBy as $a_OrderBy )
            {
                $s_SQLQuery .= $s_Separator.$a_OrderBy[ "COLUMN" ]." ";
                if ( $a_OrderBy[ "ASC" ] === false ) $s_SQLQuery .= "DESC ";
                $s_Separator = ", ";
            }
        }
        if( !is_null( $i_Position ) && is_null( $i_Rows ) ) $s_SQLQuery .= "LIMIT ".$i_Position;
        if( !is_null( $i_Position ) && !is_null( $i_Rows ) ) $s_SQLQuery .= "LIMIT ".$i_Position.", ".$i_Rows;
        $s_SQLQuery .= ";";

        if( $this->getDebug() ){ pr( $s_SQLQuery ); }

        $a_MST_ListaPrecioCabeceraBN = array();
        $o_Resource = $this->getConnect();
        $o_Statement = $o_Resource->prepareStatement( $s_SQLQuery );
        $o_ResultSet = $o_Statement->executeQuery();
        $i_NumRows = $o_ResultSet->getRecordCount();
        if( $i_NumRows > 0 )
        {
            while( $o_ResultSet->next() ) 
            {
                $a_SQLRow = $o_ResultSet->getRow(); //devuele array
                $o_MST_ListaPrecioCabeceraBN = $this->insertObjectBN( $a_SQLRow );
                $a_MST_ListaPrecioCabeceraBN[] = $o_MST_ListaPrecioCabeceraBN;
            }
        }
        return $a_MST_ListaPrecioCabeceraBN;
    }

    /* Devuelve un objeto MST_ListaPrecioCabeceraBN desde un objeto propel */
    public function insertObjectBN( $a_MST_ListaPrecioCabecera )
    {
        $o_MST_ListaPrecioCabeceraBN = new MST_ListaPrecioCabeceraBN();
        if ( !is_null( $a_MST_ListaPrecioCabecera['IdListaPreciCab'] ) ) $o_MST_ListaPrecioCabeceraBN->setIdListaPreciCab( ( integer ) $a_MST_ListaPrecioCabecera['IdListaPreciCab'] );
        if ( !is_null( $a_MST_ListaPrecioCabecera['IdCompania'] ) ) $o_MST_ListaPrecioCabeceraBN->setIdCompania( ( integer ) $a_MST_ListaPrecioCabecera['IdCompania'] );
        if ( !is_null( $a_MST_ListaPrecioCabecera['IdSucursal'] ) ) $o_MST_ListaPrecioCabeceraBN->setIdSucursal( ( integer ) $a_MST_ListaPrecioCabecera['IdSucursal'] );
        if ( !is_null( $a_MST_ListaPrecioCabecera['IdMoneda'] ) ) $o_MST_ListaPrecioCabeceraBN->setIdMoneda( $a_MST_ListaPrecioCabecera['IdMoneda'] );
        if ( !is_null( $a_MST_ListaPrecioCabecera['IdTipoLista'] ) ) $o_MST_ListaPrecioCabeceraBN->setIdTipoLista( ( integer ) $a_MST_ListaPrecioCabecera['IdTipoLista'] );
        if ( !is_null( $a_MST_ListaPrecioCabecera['Estado'] ) ) $o_MST_ListaPrecioCabeceraBN->setEstado( $a_MST_ListaPrecioCabecera['Estado'] );
        if ( !is_null( $a_MST_ListaPrecioCabecera['FechaCreacion'] ) ) $o_MST_ListaPrecioCabeceraBN->setFechaCreacion( utilTimestamp::getTimestamp( $a_MST_ListaPrecioCabecera['FechaCreacion'], "Y-m-d H:i:s" ) );
        if ( !is_null( $a_MST_ListaPrecioCabecera['UsuarioCreacion'] ) ) $o_MST_ListaPrecioCabeceraBN->setUsuarioCreacion( $a_MST_ListaPrecioCabecera['UsuarioCreacion'] );
        if ( !is_null( $a_MST_ListaPrecioCabecera['FechaModificacion'] ) ) $o_MST_ListaPrecioCabeceraBN->setFechaModificacion( utilTimestamp::getTimestamp( $a_MST_ListaPrecioCabecera['FechaModificacion'], "Y-m-d H:i:s" ) );
        if ( !is_null( $a_MST_ListaPrecioCabecera['UsuarioModificacion'] ) ) $o_MST_ListaPrecioCabeceraBN->setUsuarioModificacion( $a_MST_ListaPrecioCabecera['UsuarioModificacion'] );
        return $o_MST_ListaPrecioCabeceraBN;
    }
}
?>